package com.wastedpotential {
	import org.flixel.*;
 
	public class Player extends FlxSprite {
 
		[Embed(source="/../media/andy.png")] protected var PlayerImage:Class;
  
		protected static const PLAYER_START_X:int = 300;
		protected static const PLAYER_START_Y:int = 300;
		protected static const PLAYER_RUN_SPEED:int = 80;
		protected static const GRAVITY_ACCELERATION:Number = 500;
		protected static const JUMP_ACCELERATION:Number = 260;

		public function Player() {
			super(PLAYER_START_X, PLAYER_START_Y);
			
			width = height = 32;
			
			loadGraphic(PlayerImage, true, true, 21, 32, true);
			

			drag.x = PLAYER_RUN_SPEED * 8;
			acceleration.y = GRAVITY_ACCELERATION;
			maxVelocity.x = PLAYER_RUN_SPEED;
			maxVelocity.y = JUMP_ACCELERATION;

			addAnimation("idle", [0]);
			addAnimation("run", [2, 1], 10);
			addAnimation("jump", [1]);
			
		}
		
		//- the onEnterFrame function
		public override function update():void {
			//trace("Player :: update");
			
			//if player falls off the bottom of the screen, put him back at the top
			if (this.y > FlxG.height) { 
				this.y = -1*GameModel.tileSize;
			}
			
			//calculate current speed and acceleration
			acceleration.x = 0;
			if(FlxG.keys.LEFT) {
				facing = LEFT;
				acceleration.x = -drag.x;
			}
			else if(FlxG.keys.RIGHT) {
				facing = RIGHT;
				acceleration.x = drag.x;
			}
			if(FlxG.keys.justPressed("SPACE") && !velocity.y) {
				velocity.y = -JUMP_ACCELERATION;
			}
			
			//choose what sprite to show:
			if(velocity.y != 0) {
				play("jump");
			}
			else if(velocity.x == 0) {
				play("idle");
			}
			else {
				play("run");
			}

			super.update();
		}
		
	} //end class
} //end package

